searchData={"items":[{"type":"task","title":"mix turnkey.server","doc":"Starts an insecure Turnkey server. This can be used to enable\ntesting of the Turnkey API.\n\n# Usage\n\n`mix turnkey.server --port 8888`","ref":"Mix.Tasks.Turnkey.Server.html"},{"type":"module","title":"Turnkey","doc":"Turnkey interactions that are a little higher level than api client","ref":"Turnkey.html"},{"type":"function","title":"Turnkey.fetch_recovered_passkey_attestation/1","doc":"Read the attestation used to create the authenticator which is assigned to the turnkey suborg.","ref":"Turnkey.html#fetch_recovered_passkey_attestation/1"},{"type":"function","title":"Turnkey.initiate_recovery/3","doc":"takes embedded key from turnkey recovery iframe, and\nsub organization id looked up by us using user's email.\n\nWill trigger an email from turnkey to the user, and the user will\ncopy data from that email back into the recovery iframe.","ref":"Turnkey.html#initiate_recovery/3"},{"type":"module","title":"Turnkey.APIClient","doc":"Contextualized interfaces to Turnkey API.","ref":"Turnkey.APIClient.html"},{"type":"function","title":"Turnkey.APIClient.api_url/0","doc":"","ref":"Turnkey.APIClient.html#api_url/0"},{"type":"function","title":"Turnkey.APIClient.poll_activity/1","doc":"Polls an activity until completion","ref":"Turnkey.APIClient.html#poll_activity/1"},{"type":"function","title":"Turnkey.APIClient.post/3","doc":"All requests (query and mutate), are POST requests to facilitate signed json bodies.","ref":"Turnkey.APIClient.html#post/3"},{"type":"module","title":"Turnkey.APIClient.Activity","doc":"Turnkey mutating actions create an \"Activity\", with a status that\nindicates whether the endpoint should be polled until the status is \"Completed\"\n\nSome activities complete immediately, including signing.\nSome activities take time, including creating sub orgs and if the action\nrequires a quorum.\n\nhttps://docs.turnkey.com/api#tag/Activities","ref":"Turnkey.APIClient.Activity.html"},{"type":"function","title":"Turnkey.APIClient.Activity.get_activity/3","doc":"Queries an activity, polling until completion if requested.","ref":"Turnkey.APIClient.Activity.html#get_activity/3"},{"type":"function","title":"Turnkey.APIClient.Activity.list_activities/1","doc":"","ref":"Turnkey.APIClient.Activity.html#list_activities/1"},{"type":"module","title":"Turnkey.APIClient.EmailRecovery","doc":"Our organization api key can initiate an email recovery process for a user.\n\n\nhttps://docs.turnkey.com/api#tag/User-Recovery/operation/InitUserEmailRecovery","ref":"Turnkey.APIClient.EmailRecovery.html"},{"type":"function","title":"Turnkey.APIClient.EmailRecovery.init_user_email_recovery/3","doc":"Create the user email recovery activity, which will send the user an email and allow them to continue the process on our recovery webpage","ref":"Turnkey.APIClient.EmailRecovery.html#init_user_email_recovery/3"},{"type":"module","title":"Turnkey.APIClient.Signer","doc":"Turnkey client for signing data\n\nhttps://docs.turnkey.com/api#tag/Signers/operation/SignRawPayload","ref":"Turnkey.APIClient.Signer.html"},{"type":"function","title":"Turnkey.APIClient.Signer.sign/4","doc":"Signs the given payload using the given key.\n\nTODO: How do we provide a Webauthn sig?","ref":"Turnkey.APIClient.Signer.html#sign/4"},{"type":"module","title":"Turnkey.APIClient.Stamper","doc":"Generates an api key stamp header for turnkey api requests, which is built by signing the entire\nbody of a post request with the api key.","ref":"Turnkey.APIClient.Stamper.html"},{"type":"function","title":"Turnkey.APIClient.Stamper.stamp/1","doc":"","ref":"Turnkey.APIClient.Stamper.html#stamp/1"},{"type":"function","title":"Turnkey.APIClient.Stamper.stamp_with/2","doc":"Generates a Base64URL-encoded Turnkey Stamp with the given message and key tuple.","ref":"Turnkey.APIClient.Stamper.html#stamp_with/2"},{"type":"function","title":"Examples - Turnkey.APIClient.Stamper.stamp_with/2","doc":"iex> import Turnkey.APIClient.Stamper, only: [stamp_with: 2]\niex> tk_public_key = \"0371dd5ab2de3ba282ec0d5ee32a5425acd9280a1d70c5bb0e04d5c26d8ce04c41\"\niex> tk_private_key = \"f2c9fa33bb68809f0c716542aa4fe2b5ee536f0472fbfce482f4a7b931d42fe0\" |> Base.decode16!(case: :lower)\niex> message = ~s<{\"organizationId\": \"105d7217-3600-42b5-a818-226efdb25019\"}>\niex> stamp = stamp_with(message, { tk_public_key, tk_private_key })\niex> %{public_key: tk_public_key, scheme: \"SIGNATURE_SCHEME_TK_API_P256\", signature: signature} = stamp\n...> |> Base.url_decode64!(padding: false)\n...> |> Jason.decode!(keys: :atoms)\niex> pk_bytes = Base.decode16!(tk_public_key, case: :lower)\niex> :crypto.verify(:ecdsa, :sha256, message, Base.decode16!(signature), [pk_bytes, :secp256r1])\ntrue\n\nNote: The actual return value of `encoded_stamp` is not shown here because it is\nnon-deterministic due to the cryptographic signing process.","ref":"Turnkey.APIClient.Stamper.html#stamp_with/2-examples"},{"type":"module","title":"Turnkey.APIClient.SubOrganization","doc":"Turnkey Sub Organizations allow for a permissioning model where our users\n  have control over their keys and our api key has read access only.\n\n  https://docs.turnkey.com/api#tag/Organizations","ref":"Turnkey.APIClient.SubOrganization.html"},{"type":"function","title":"Turnkey.APIClient.SubOrganization.create_sub_organization_from_authenticator/2","doc":"All users are given a suborganization controlled by their passkey ( authenticator_params ).\nIt is created with a single Ethereum private key.\nOur api key retains read access.\n\nThis is an asyncronous activity, so the activity is polled until completion.","ref":"Turnkey.APIClient.SubOrganization.html#create_sub_organization_from_authenticator/2"},{"type":"module","title":"Turnkey.APIClient.SubOrganization.TrimmedResult","doc":"A struct for shaping the turnkey result + request towards our needs,\nsince the activity is too hefty but the Result doesn't have everything we need.","ref":"Turnkey.APIClient.SubOrganization.TrimmedResult.html"},{"type":"module","title":"Turnkey.APIServer.Server","doc":"","ref":"Turnkey.APIServer.Server.html"},{"type":"function","title":"Turnkey.APIServer.Server.child_spec/1","doc":"","ref":"Turnkey.APIServer.Server.html#child_spec/1"},{"type":"function","title":"Turnkey.APIServer.Server.start_link/1","doc":"","ref":"Turnkey.APIServer.Server.html#start_link/1"},{"type":"module","title":"Turnkey.APIServer.Server.CORS","doc":"","ref":"Turnkey.APIServer.Server.CORS.html"},{"type":"function","title":"Turnkey.APIServer.Server.CORS.call/2","doc":"","ref":"Turnkey.APIServer.Server.CORS.html#call/2"},{"type":"function","title":"Turnkey.APIServer.Server.CORS.init/1","doc":"","ref":"Turnkey.APIServer.Server.CORS.html#init/1"},{"type":"module","title":"Turnkey.APIServer.Server.Persistance","doc":"","ref":"Turnkey.APIServer.Server.Persistance.html"},{"type":"function","title":"Turnkey.APIServer.Server.Persistance.load!/1","doc":"","ref":"Turnkey.APIServer.Server.Persistance.html#load!/1"},{"type":"function","title":"Turnkey.APIServer.Server.Persistance.store!/2","doc":"","ref":"Turnkey.APIServer.Server.Persistance.html#store!/2"},{"type":"module","title":"Turnkey.APIServer.Server.PlaintextJsonParser","doc":"","ref":"Turnkey.APIServer.Server.PlaintextJsonParser.html"},{"type":"function","title":"Turnkey.APIServer.Server.PlaintextJsonParser.init/1","doc":"","ref":"Turnkey.APIServer.Server.PlaintextJsonParser.html#init/1"},{"type":"function","title":"Turnkey.APIServer.Server.PlaintextJsonParser.parse/5","doc":"","ref":"Turnkey.APIServer.Server.PlaintextJsonParser.html#parse/5"},{"type":"module","title":"Turnkey.APIServer.Server.Router","doc":"","ref":"Turnkey.APIServer.Server.Router.html"},{"type":"function","title":"Turnkey.APIServer.Server.Router.call/2","doc":"","ref":"Turnkey.APIServer.Server.Router.html#call/2"},{"type":"function","title":"Turnkey.APIServer.Server.Router.init/1","doc":"","ref":"Turnkey.APIServer.Server.Router.html#init/1"},{"type":"module","title":"Turnkey.APIServer.Server.Server","doc":"","ref":"Turnkey.APIServer.Server.Server.html"},{"type":"function","title":"Turnkey.APIServer.Server.Server.call/2","doc":"","ref":"Turnkey.APIServer.Server.Server.html#call/2"},{"type":"function","title":"Turnkey.APIServer.Server.Server.init/1","doc":"","ref":"Turnkey.APIServer.Server.Server.html#init/1"},{"type":"module","title":"Turnkey.APITypes","doc":"Just some simple structs to give a little more flavor and confidence to the api interactions","ref":"Turnkey.APITypes.html"},{"type":"module","title":"Turnkey.APITypes.ApiKey","doc":"","ref":"Turnkey.APITypes.ApiKey.html"},{"type":"type","title":"Turnkey.APITypes.ApiKey.t/0","doc":"","ref":"Turnkey.APITypes.ApiKey.html#t:t/0"},{"type":"module","title":"Turnkey.APITypes.Authenticator","doc":"","ref":"Turnkey.APITypes.Authenticator.html"},{"type":"type","title":"Turnkey.APITypes.Authenticator.t/0","doc":"","ref":"Turnkey.APITypes.Authenticator.html#t:t/0"},{"type":"module","title":"Turnkey.APITypes.Authenticator.Attestation","doc":"","ref":"Turnkey.APITypes.Authenticator.Attestation.html"},{"type":"type","title":"Turnkey.APITypes.Authenticator.Attestation.t/0","doc":"","ref":"Turnkey.APITypes.Authenticator.Attestation.html#t:t/0"},{"type":"module","title":"Turnkey.APITypes.CreateActivity","doc":"The root of a creation payload","ref":"Turnkey.APITypes.CreateActivity.html"},{"type":"type","title":"Turnkey.APITypes.CreateActivity.t/0","doc":"","ref":"Turnkey.APITypes.CreateActivity.html#t:t/0"},{"type":"module","title":"Turnkey.APITypes.CreateSubOrganizationIntentV4","doc":"","ref":"Turnkey.APITypes.CreateSubOrganizationIntentV4.html"},{"type":"type","title":"Turnkey.APITypes.CreateSubOrganizationIntentV4.t/0","doc":"","ref":"Turnkey.APITypes.CreateSubOrganizationIntentV4.html#t:t/0"},{"type":"module","title":"Turnkey.APITypes.CreateSubOrganizationResultV4","doc":"The wrapper for a turnkey activity requests result\ne.g. %{ \n\"subOrganizationId\" => \"5d0ef3dc-e8f9-4d51-bc90-76bf24599c9a\",\n\"wallet\" => %{\n  \"addresses\" => [\"0xC63C30d1227fD5568a99807D285e3ffFFa246c8d\"],\n  \"walletId\" => \"c384284a-849c-5158-934c-4f497bcff731\"\n}","ref":"Turnkey.APITypes.CreateSubOrganizationResultV4.html"},{"type":"module","title":"Turnkey.APITypes.CreateSubOrganizationResultV4.Wallet","doc":"","ref":"Turnkey.APITypes.CreateSubOrganizationResultV4.Wallet.html"},{"type":"module","title":"Turnkey.APITypes.InitUserEmailRecoveryIntent","doc":"The wrapper for initializing user email recovery intent\ne.g. %{\n\"email\" => \"example@example.com\",\n\"targetPublicKey\" => \"abc123def456...\",\n\"expirationSeconds\" => \"3600\"\n}","ref":"Turnkey.APITypes.InitUserEmailRecoveryIntent.html"},{"type":"module","title":"Turnkey.APITypes.InitUserEmailRecoveryResult","doc":"The wrapper for the result of an init user email recovery action\ne.g. %{\n\"userId\" => \"a1b2c3d4-e5f6-7890-g1h2-i3j4k5l6m7n8\"\n}","ref":"Turnkey.APITypes.InitUserEmailRecoveryResult.html"},{"type":"module","title":"Turnkey.APITypes.ListActivitiesRequest","doc":"Represents a request for user activity.","ref":"Turnkey.APITypes.ListActivitiesRequest.html"},{"type":"type","title":"Turnkey.APITypes.ListActivitiesRequest.t/0","doc":"","ref":"Turnkey.APITypes.ListActivitiesRequest.html#t:t/0"},{"type":"module","title":"Turnkey.APITypes.ListActivitiesRequest.PaginationOptions","doc":"","ref":"Turnkey.APITypes.ListActivitiesRequest.PaginationOptions.html"},{"type":"type","title":"Turnkey.APITypes.ListActivitiesRequest.PaginationOptions.t/0","doc":"","ref":"Turnkey.APITypes.ListActivitiesRequest.PaginationOptions.html#t:t/0"},{"type":"module","title":"Turnkey.APITypes.RecoverUserIntent","doc":"The Intent or recovering a user.\nSent by the user when recovering. We have it for parsing the intent when reading bach the activity.\ne.g. %{\n\"authenticator\": {\n  \"authenticatorName\": \"string\",\n  \"challenge\": \"string\",\n  \"attestation\": {}\n  },\n\"userId\": \"string\"\n}","ref":"Turnkey.APITypes.RecoverUserIntent.html"},{"type":"type","title":"Turnkey.APITypes.RecoverUserIntent.t/0","doc":"","ref":"Turnkey.APITypes.RecoverUserIntent.html#t:t/0"},{"type":"module","title":"Turnkey.APITypes.RootUser","doc":"","ref":"Turnkey.APITypes.RootUser.html"},{"type":"type","title":"Turnkey.APITypes.RootUser.t/0","doc":"","ref":"Turnkey.APITypes.RootUser.html#t:t/0"},{"type":"module","title":"Turnkey.APITypes.Wallet","doc":"","ref":"Turnkey.APITypes.Wallet.html"},{"type":"type","title":"Turnkey.APITypes.Wallet.t/0","doc":"","ref":"Turnkey.APITypes.Wallet.html#t:t/0"},{"type":"module","title":"Turnkey.APITypes.Wallet.Account","doc":"","ref":"Turnkey.APITypes.Wallet.Account.html"},{"type":"type","title":"Turnkey.APITypes.Wallet.Account.t/0","doc":"","ref":"Turnkey.APITypes.Wallet.Account.html#t:t/0"},{"type":"module","title":"Turnkey.Fixtures","doc":"","ref":"Turnkey.Fixtures.html"},{"type":"function","title":"Turnkey.Fixtures.sample_authenticator/0","doc":"","ref":"Turnkey.Fixtures.html#sample_authenticator/0"},{"type":"function","title":"Turnkey.Fixtures.sample_sub_organization_create/1","doc":"","ref":"Turnkey.Fixtures.html#sample_sub_organization_create/1"},{"type":"module","title":"Turnkey.Instructer","doc":"Put maps into structs and return error tuple while enforcing keys.\n`struct/2` fails to enforce keys and `struct!/2` crashes, so this module\nwraps `struct!/2` with try rescue.\n\nIt also handles assigning nested structs and critically plays nicely with @enforce_keys","ref":"Turnkey.Instructer.html"},{"type":"function","title":"Turnkey.Instructer.instructify/3","doc":"Converts a map to a struct, enforcing the presence of all keys.\nIf the conversion fails, returns an error tuple.","ref":"Turnkey.Instructer.html#instructify/3"},{"type":"function","title":"Examples - Turnkey.Instructer.instructify/3","doc":"iex> cat_params = %{\n    ...>   \"user_name\" => \"test_user\",\n    ...>   \"friend\" => %{\"bark\" => \"abc123\", \"bite\" => \"data\"}\n    ...> }\n    iex> Turnkey.Instructer.instructify(\n    ...>   cat_params,\n    ...>   {Cat, friend: Cat.Dog}\n    ...> )\n    {:ok, %Cat{friend: %Cat.Dog{bark: \"abc123\", bite: \"data\"}, user_name: \"test_user\"}}\n\n    iex> bad_dog = %{\n    ...>   \"user_name\" => \"test_user\",\n    ...>   \"friend\" => %{\"bark\" => \"abc123\"}\n    ...> }\n    iex> Turnkey.Instructer.instructify(\n    ...>   bad_dog,\n    ...>   {Cat, friend: Cat.Dog}\n    ...> )\n    {:error,  {:instructer_parsing_error, \"the following keys must also be given when building struct Turnkey.InstructerTest.Cat.Dog: [:bite] found only %{\\\"bark\\\" => \\\"abc123\\\"} as %{bark: \\\"abc123\\\"}\"}}\n\n    iex> extra_keys_ignored = %{\n    ...>   \"user_name\" => \"test_user\",\n    ...>   \"friend\" => %{\"bark\" => \"abc123\", \"bite\" => \"data\", \"fuggedabaoutit\" => \"abc123\"}\n    ...> }\n    iex> Turnkey.Instructer.instructify(\n    ...>   extra_keys_ignored,\n    ...>   {Cat, friend: Cat.Dog}\n    ...> )\n    {:ok, %Cat{friend: %Cat.Dog{bark: \"abc123\", bite: \"data\"}, user_name: \"test_user\"}}","ref":"Turnkey.Instructer.html#instructify/3-examples"},{"type":"function","title":"Turnkey.Instructer.instructify!/2","doc":"","ref":"Turnkey.Instructer.html#instructify!/2"},{"type":"function","title":"Turnkey.Instructer.js_camelize/1","doc":"","ref":"Turnkey.Instructer.html#js_camelize/1"},{"type":"function","title":"Turnkey.Instructer.struct_from_string_keys!/3","doc":"","ref":"Turnkey.Instructer.html#struct_from_string_keys!/3"},{"type":"module","title":"Turnkey.TestClient","doc":"","ref":"Turnkey.TestClient.html"},{"type":"function","title":"Turnkey.TestClient.post/3","doc":"","ref":"Turnkey.TestClient.html#post/3"},{"type":"module","title":"TurnkeyMock","doc":"","ref":"TurnkeyMock.html"},{"type":"function","title":"TurnkeyMock.child_spec/1","doc":"","ref":"TurnkeyMock.html#child_spec/1"},{"type":"function","title":"TurnkeyMock.start_link/1","doc":"","ref":"TurnkeyMock.html#start_link/1"},{"type":"module","title":"TurnkeyMock.CORS","doc":"","ref":"TurnkeyMock.CORS.html"},{"type":"function","title":"TurnkeyMock.CORS.call/2","doc":"","ref":"TurnkeyMock.CORS.html#call/2"},{"type":"function","title":"TurnkeyMock.CORS.init/1","doc":"","ref":"TurnkeyMock.CORS.html#init/1"},{"type":"module","title":"TurnkeyMock.Persistance","doc":"","ref":"TurnkeyMock.Persistance.html"},{"type":"function","title":"TurnkeyMock.Persistance.load!/1","doc":"","ref":"TurnkeyMock.Persistance.html#load!/1"},{"type":"function","title":"TurnkeyMock.Persistance.store!/2","doc":"","ref":"TurnkeyMock.Persistance.html#store!/2"},{"type":"module","title":"TurnkeyMock.PlaintextJsonParser","doc":"","ref":"TurnkeyMock.PlaintextJsonParser.html"},{"type":"function","title":"TurnkeyMock.PlaintextJsonParser.init/1","doc":"","ref":"TurnkeyMock.PlaintextJsonParser.html#init/1"},{"type":"function","title":"TurnkeyMock.PlaintextJsonParser.parse/5","doc":"","ref":"TurnkeyMock.PlaintextJsonParser.html#parse/5"},{"type":"module","title":"TurnkeyMock.Router","doc":"","ref":"TurnkeyMock.Router.html"},{"type":"function","title":"TurnkeyMock.Router.call/2","doc":"","ref":"TurnkeyMock.Router.html#call/2"},{"type":"function","title":"TurnkeyMock.Router.init/1","doc":"","ref":"TurnkeyMock.Router.html#init/1"},{"type":"module","title":"TurnkeyMock.Server","doc":"","ref":"TurnkeyMock.Server.html"},{"type":"function","title":"TurnkeyMock.Server.call/2","doc":"","ref":"TurnkeyMock.Server.html#call/2"},{"type":"function","title":"TurnkeyMock.Server.init/1","doc":"","ref":"TurnkeyMock.Server.html#init/1"},{"type":"extras","title":"Turnkey","doc":"# Turnkey\n\nTurnkey is an unofficial client to the [Turnkey API](https://www.turnkey.com/).","ref":"readme.html"},{"type":"extras","title":"Installation - Turnkey","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `turnkey` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:turnkey, \"~> 0.0.1-alpha1\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Tests - Turnkey","doc":"```\nmix test\n```","ref":"readme.html#tests"},{"type":"extras","title":"Contributing - Turnkey","doc":"Create a PR to contribute to TurnkeyEx. All contributors agree to accept the license specified in this repository for all contributions to this project. See [LICENSE.md](/LICENSE.md).\n\nFeel free to create Feature Requests in the issues.","ref":"readme.html#contributing"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,49,46,50]}}